
#include "User.h"

// Fcpu=1/2M: 4
// Fcpu=1M: 9
// Fcpu=2M: 20
// Fcpu=4M: 42
// Fcpu=8M: 87

#define RF_ChannelValue        	0  //ͨ
//------------------------------
#define	Delay_100us_Num_Temp   	20
//------------------------------
#define	RX_DataLengthMax_Value 	4  //õݸ
//------------------------------
#define	SyncWord_Addr1 	72
#define	SyncWord_Data1 	0xAA

#define	SyncWord_Addr2 	73
#define	SyncWord_Data2 	0xBB

#define	SyncWord_Addr3 	78             	       	
#define	SyncWord_Data3 	0xCC

#define	SyncWord_Addr4 	79             	
#define	SyncWord_Data4 	0xDD
//------------------------------

#define	RF_CLK         	       	P14D
#define	RF_CSn         	       	P13D
#define	RF_CE       	       	P07D
#define	RF_MOSI_MISO   	       	P00D
#define	RF_PKT   	       		P03D

#define	RF_MOSI_MISO_DDR       	P00OE
//------------------------------
#define	RF_MOSI_Input  	       	1
#define	RF_MOSI_Output 			0

uchar RF_InitIndex;
uchar RF_RegAddr;
uchar RF_Init_RegData_Temp;
uchar RF_RegData;
uchar TX_RX_DataLength_Temp;
uchar SPI_Cyc_Cnt;
uchar SPI_BUF;
uchar Delay_100us_Num1,Delay_100us_Num2;


//------------------------------
const uchar RF_InitTab[]=
{
       	04,0xC2,
   	   	17,0x3A,
       	18,0x0C,       	       	//书
       	34,0x08,
   	   	35,0x08,
       	45,0x00,
   //	   	46,0x09,
       	52,0x1A,
       	53,0x40,
       	64,0x78,       	       	//ݰʽ
       	72,0x55,
       	73,0x55,
       	74,0x55,
       	75,0x55,
       	76,0xAA,
       	77,0x3E,
       	78,0x57,
       	79,0xE4,
       	80,0xF8,
       	81,0x47,       	       	
       	0xFF
};
//------------------------------
uchar RF_Init_Deal(void)
{
       	Delay_100us_Deal(40);

       	SPI_CKPHA_Flag=0; 
       	SPI_WriteReg_Deal(30,0x00); 
       	SPI_CKPHA_Flag=1;      	

       	SPI_WriteReg_Deal(94,0x80);    	
       	
       	for(RF_InitIndex=0;RF_InitIndex<100;RF_InitIndex++)
       	{
       	       	RF_RegAddr=RF_InitTab[RF_InitIndex*2];
       	       	if(0xFF==RF_RegAddr)
       	       	{
       	       	       	break; 	       	       	
       	       	}
       	       	RF_RegData=RF_InitTab[RF_InitIndex*2+1];
       	       	RF_Init_RegData_Temp=RF_RegData;
       	       	
       	       	SPI_WriteReg_Deal(RF_RegAddr,RF_RegData);
       	       	
       	       	SPI_ReadReg_Deal(RF_RegAddr);
       	       	
       	       	if(RF_Init_RegData_Temp!=RF_RegData)
       	       	{
       	       	       	return 0;
       	       	}
       	}
       	SPI_WriteReg_Deal(46,0x09);
       	return 1;
}
//------------------------------
void RF_TX_Deal(void)
{
       	SPI_WriteReg_Deal(15,RF_ChannelValue);
       	
       	SPI_WriteReg_Deal(14,0x01);
}
//------------------------------
void RF_TX_PKT_Deal(void)
{
       	do
       	{
       	       	SPI_ReadReg_Deal(97);  	       	
       	}
       	while(0x40!=(RF_RegData&0x40));
}
//------------------------------
void RF_TX_250K_Deal(void)
{
       	SPI_WriteReg_Deal(64,0x68);

       	SPI_WriteReg_Deal(106,0x68);

       	SPI_WriteReg_Deal(107,0xC3);

       	SPI_WriteReg_Deal(108,0x16);

       	SPI_WriteReg_Deal(109,0x7C);

       	SPI_WriteReg_Deal(110,0x6E);

       	SPI_WriteReg_Deal(111,0xA1);
}

//------------------------------
void RF_RX_Deal(void)
{
       	SPI_WriteReg_Deal(14,0x00);
       	
       	SPI_WriteReg_Deal(15,0x80+RF_ChannelValue);
}
//------------------------------
void RF_RX_250K_Deal(void)
{
       	SPI_WriteReg_Deal(64,0x68);

       	SPI_WriteReg_Deal(106,0x68);

       	SPI_WriteReg_Deal(107,0xC3);

       	SPI_WriteReg_Deal(108,0x7A);

       	SPI_WriteReg_Deal(109,0x89);

       	SPI_WriteReg_Deal(110,0xC1);

       	SPI_WriteReg_Deal(111,0x97);
}
//------------------------------
void RF_Idle_Deal(void)
{
       	SPI_WriteReg_Deal(14,0);
       	
       	SPI_WriteReg_Deal(15,0);       	
}
//------------------------------
void RF_Sleep_Deal(void)
{
       	SPI_ReadReg_Deal(70);
       	
       	RF_RegData=RF_RegData|0x40;
       	
       	SPI_WriteReg_Deal(70,RF_RegData);
}
//------------------------------
void RF_Wakeup_Deal(void)
{
       	RF_CSn=0;
       	
       	Delay_100us_Deal(40);
       	
       	RF_CSn=1;
}
//------------------------------
void RF_WriteFIFO_Deal(void)
{
       	RF_CSn=0;
       	SPI_WriteBit_Deal(100);
       	
       	for(TX_RX_DataLength_Temp=0;TX_RX_DataLength_Temp<=TX_RX_DataLength[0];TX_RX_DataLength_Temp++)
       	{
       	       	SPI_WriteBit_Deal(TX_RX_DataLength[TX_RX_DataLength_Temp]);
       	}
       	RF_CSn=1;
}
//------------------------------
void RF_ResetWriteFIFO_Deal(void)
{
       	SPI_WriteReg_Deal(104,0x80);   	
}
//------------------------------
void RF_ReadFIFO_Deal(void)
{
       	RF_ReadFIFOError_Flag=0;
       	
       	SPI_ReadReg_Deal(96);
       	
       	if(0==(RF_RegData&0x80))
       	{
       	       	RF_CSn=0;
       	       	Nop();
       	       	Nop();
       	       	SPI_WriteBit_Deal(100|0x80);
       	       	Nop();
       	       	Nop();
       	       	TX_RX_DataLength[0]=SPI_ReadBit_Deal();
       	       	if((TX_RX_DataLength[0]<=RX_DataLengthMax_Value)&&(TX_RX_DataLength[0]!=0))
       	       	{
       	       	       	for(TX_RX_DataLength_Temp=1;TX_RX_DataLength_Temp<=TX_RX_DataLength[0];TX_RX_DataLength_Temp++)
       	       	       	{
       	       	       	       	TX_RX_DataLength[TX_RX_DataLength_Temp]=SPI_ReadBit_Deal();
       	       	       	}
       	       	}
       	       	else 
       	       	{
       	       	       	RF_ReadFIFOError_Flag=1;
       	       	}
       	       	RF_CSn=1;
       	}
       	else 
       	{
       	       	RF_ReadFIFOError_Flag=1;
       	}
}
//------------------------------
void RF_ResetReadFIFO_Deal(void)
{
       	SPI_WriteReg_Deal(105,0x80);
}
//------------------------------
void SPI_WriteReg_Deal(uchar RF_RegAddr_Temp,uchar RF_RegData_Temp)
{
       	RF_CSn=0;
       	SPI_WriteBit_Deal(RF_RegAddr_Temp);
       	Nop();
       	SPI_WriteBit_Deal(RF_RegData_Temp);
       	RF_CSn=1;
}
//------------------------------
void SPI_WriteBit_Deal(uchar SPI_BUF_Temp)
{
       	#if RF_MOSI_Output
       	       	RF_MOSI_MISO_DDR=1;
       	#else 
       	       	RF_MOSI_MISO_DDR=0;
       	#endif
       	
       	for(SPI_Cyc_Cnt=0;SPI_Cyc_Cnt<8;SPI_Cyc_Cnt++)
       	{
       	       	if(0==SPI_CKPHA_Flag)
       	       	{
       	       	       	RF_CLK=1;
       	       	}
       	       	else
       	       	{
       	       	       	RF_CLK=0;
       	       	}

       	       	if(0x80==(SPI_BUF_Temp&0x80))
       	       	{
       	       	       	RF_MOSI_MISO=1;
       	       	}
       	       	else 
       	       	{
       	       	       	RF_MOSI_MISO=0;
       	       	}
       	       	Nop();
       	       	Nop();
       	       	

       	       	if(0==SPI_CKPHA_Flag)
       	       	{
       	       	       	RF_CLK=0;
       	       	}
       	       	else
       	       	{
       	       	       	RF_CLK=1;
       	       	}
       	       	SPI_BUF_Temp=SPI_BUF_Temp<<1;
       	}
       	RF_CLK=0;
}
//------------------------------
void SPI_ReadReg_Deal(uchar RF_RegAddr_Temp)
{
       	RF_CSn=0;
       	Nop();
       	SPI_WriteBit_Deal(0x80|RF_RegAddr_Temp);
       	Nop();
       	RF_RegData=SPI_ReadBit_Deal();
       	RF_CSn=1;

       	#if RF_MOSI_Output 
       	       	RF_MOSI_MISO_DDR=1;
       	#else 
       	       	RF_MOSI_MISO_DDR=0;
       	#endif
}
//------------------------------
uchar SPI_ReadBit_Deal(void)
{
       	#if RF_MOSI_Input
       	       	RF_MOSI_MISO_DDR=1;
       	#else 
       	       	RF_MOSI_MISO_DDR=0;
       	#endif 	

       	for(SPI_Cyc_Cnt=0;SPI_Cyc_Cnt<8;SPI_Cyc_Cnt++)
       	{
       	       	if(0==SPI_CKPHA_Flag)
       	       	{
       	       	       	RF_CLK=1;
       	       	       	Nop();
       	       	       	Nop();
       	       	       	RF_CLK=0;
       	       	}
       	       	else
       	       	{
       	       	       	RF_CLK=0;
       	       	       	Nop();
       	       	       	Nop();
       	       	       	RF_CLK=1;
       	       	}

       	       	Nop();
       	       	SPI_BUF=SPI_BUF<<1;
       	       	if(1==RF_MOSI_MISO)
       	       	{
       	       	       	SPI_BUF++;
       	       	}
       	}
       	RF_CLK=0;
       	return SPI_BUF;
}
//------------------------------
void Delay_100us_Deal(uchar Delay_100us_Num)
{
       	for(Delay_100us_Num1=Delay_100us_Num;Delay_100us_Num1>0;Delay_100us_Num1--)
       	       	for(Delay_100us_Num2=0;Delay_100us_Num2<Delay_100us_Num_Temp;Delay_100us_Num2++);
}
//------------------------------
void RF_SetSyncWord_Deal(void)
{
       	SPI_WriteReg_Deal(SyncWord_Addr1,SyncWord_Data1);
       	SPI_WriteReg_Deal(SyncWord_Addr2,SyncWord_Data2);
       	SPI_WriteReg_Deal(SyncWord_Addr3,SyncWord_Data3);
       	SPI_WriteReg_Deal(SyncWord_Addr4,SyncWord_Data4);
}
