
#ifndef USER
#define USER

#include "mc32-common.h"
#include "mc32F7062.h"

#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long int
#define uint8_t  unsigned char
#define uint16_t unsigned int
#define uint32_t unsigned long int

#define DEF_SET_BIT0           	   	0x01
#define DEF_SET_BIT1           	   	0x02
#define DEF_SET_BIT2           	   	0x04
#define DEF_SET_BIT3           	   	0x08
#define DEF_SET_BIT4           	   	0x10
#define DEF_SET_BIT5           	   	0x20
#define DEF_SET_BIT6           	   	0x40
#define DEF_SET_BIT7           	   	0x80

#define DEF_CLR_BIT0           	   	0xFE
#define DEF_CLR_BIT1           	   	0xFD
#define DEF_CLR_BIT2           	   	0xFB
#define DEF_CLR_BIT3           	   	0xF7
#define DEF_CLR_BIT4           	   	0xEF
#define DEF_CLR_BIT5           	   	0xDF
#define DEF_CLR_BIT6           	   	0xBF
#define DEF_CLR_BIT7           	   	0x7F

#define ENABLE 	           	   	1
#define DISABLE            	   	0

#define FAIL   	           	   	1
#define PASS               	   	0

//===============Field Protection Variables===============


//===============IO Define===============

//===============Global Variable===============
extern 	uchar TX_RX_DataLength[5];
extern 	uchar RF_RegData;
//===============Global Function===============
void InitSys(void);
uchar RF_Init_Deal(void);
void RF_TX_Deal(void);
void RF_TX_PKT_Deal(void);
void RF_TX_250K_Deal(void);
void RF_RX_Deal(void);
void RF_RX_250K_Deal(void);
void RF_Idle_Deal(void);
void RF_Sleep_Deal(void);
void RF_Wakeup_Deal(void);
void RF_WriteFIFO_Deal(void);
void RF_ResetWriteFIFO_Deal(void);
void RF_ReadFIFO_Deal(void);
void RF_ResetReadFIFO_Deal(void);
void SPI_WriteReg_Deal(uchar RF_RegAddr_Temp,uchar RF_RegData_Temp);
void SPI_WriteBit_Deal(uchar SPI_BUF);
void SPI_ReadReg_Deal(uchar RF_RegAddr_Temp);
uchar SPI_ReadBit_Deal(void);
void Delay_100us_Deal(uchar Delay_100us_Num);
void RF_SetSyncWord_Deal(void);


//===============Define  Flag===============
typedef union {
   	unsigned char byte;
   	struct
   	{
   	   	u8 bit0 : 1;
   	   	u8 bit1 : 1;
   	   	u8 bit2 : 1;
   	   	u8 bit3 : 1;
   	   	u8 bit4 : 1;
   	   	u8 bit5 : 1;
   	   	u8 bit6 : 1;
   	   	u8 bit7 : 1;
   	} bits;
}bit_flag;

extern volatile bit_flag Flag1;

#define	TX_RX_Change_Flag      	       	Flag1.bits.bit0
#define	TNms_Flag      	       	       	Flag1.bits.bit1
#define	RF_ReadFIFOError_Flag  	       	Flag1.bits.bit2
#define	SPI_CKPHA_Flag 	   	   	   	   	Flag1.bits.bit3

#endif

/**************************** end of file *********************************************/