#include <mc32p7311.inc>

;**************************************
; Fcpu=1/2M: 13
; Fcpu=1M: 30
; Fcpu=2M: 63
; Fcpu=4M: 130
; Fcpu=8M: 55
#define	Delay_100us_Num_Temp   	63
;**************************************
#define	RX_DataLengthMax_Value 	4
;**************************************
#define	SyncWord_Addr1 	       	72
#define	SyncWord_Data1 	       	0xAA

#define	SyncWord_Addr2 	       	73
#define	SyncWord_Data2 	       	0xBB

#define	SyncWord_Addr3 	       	78             	       	
#define	SyncWord_Data3 	       	0xCC

#define	SyncWord_Addr4 	       	79             	
#define	SyncWord_Data4 	       	0xDD
;**************************************
#define	RF_CE  	       	       	IOP1,4
#define	RF_CLK         	       	IOP0,5
#define	RF_CSn         	       	IOP1,0
#define	RF_MOSI        	       	IOP0,3
#define	RF_MISO	       	       	IOP0,4
#define	RF_PKT 	       	       	IOP0,2

#define	TX_LED_P12     	       	IOP1,2
#define	RX_LED_P11     	       	IOP1,1
;**************************************
;ʱ˺ͽնӦĶֿ
;һʱΪ4msΪ500ms;һʱΪ8msΪ1000ms
#define	TNms_Value     	       	125;125*32us=4ms

;#define       	TNms_Value     	       	250;250*32us=8ms
;**************************************

cblock 	       	00h
acctemp
statustemp
Flag

TX_RX_DataLength
TX_RX_Data1
TX_RX_Data2
TX_RX_Data3
TX_RX_Data4

RF_InitIndex
RF_ChannelValue
RF_RegAddr
RF_RegData
RF_RegData_Temp
SPI_BUF
SPI_Cyc_Cnt

TX_RX_DataLength_Temp

Delay_100us_Num1
Delay_100us_Num2

T1S_Num
endc


#define	RF_ReadFIFOError_Flag  	Flag,0
#define	SPI_CKPHA_Flag 	       	Flag,1
#define	TNms_Flag      	       	Flag,2
#define	TX_RX_Change_Flag      	Flag,3

       	org    	       	0x00
       	goto   	       	Start

ID1_Tab:
       	retai  	       	0xFF
ID2_Tab:
       	retai  	       	0xFF
ID3_Tab:
       	retai  	       	0xFF

       	org    	       	08h
       	goto   	       	All_Int

#include "MC3090_4SPI_Demo.asm"

All_Int:
       	movra  	       	acctemp
       	swapar 	       	PFLAG
       	movra  	       	statustemp

       	jbset  	       	T0IF
       	goto   	       	All_Int_Over
       	bclr   	       	T0IF

       	bset   	       	TNms_Flag

All_Int_Over:
       	swapar 	       	statustemp
       	movra  	       	PFLAG
       	swapr  	       	acctemp
       	swapar 	       	acctemp
       	retie 


Start:  
;=========  IO  ==================
;SPI_CSn=1
Start_Init_IO:
        movai  	       	0x00
        movra  	       	IOP0  
       	movai  	       	0xEB;1110 1011
        movra  	       	OEP0
        movai  	       	0x00
        movra  	       	IOP0    

       	movai  	       	0x01
       	movra  	       	IOP1                   	
        movai  	       	0xFF;1111 1111
       	movra  	       	OEP1
       	movai  	       	0x01
       	movra  	       	IOP1
;========= CLR  RAM ==============
        clrr           	FSR0   
        clrr           	INDF0                       
        incr           	FSR0
        movai          	0xFF
        rsubar         	FSR0
        jbset          	Z
        goto           	$-5
       	clrr   	       	0xFF
;=========  RF  ==================
       	call   	       	RF_Init_Deal
;=========  Timer  ===============
Start_Init_Timer:
       	movai  	       	0x86;1000 0110
       	movra  	       	T0CR
       	
       	movai  	       	TNms_Value
       	movra  	       	T0CNT
       	movra  	       	T0LOAD

       	bclr   	       	T0IF
       	bset   	       	T0IE
       	bset   	       	GIE

       	movai  	       	0
       	movra  	       	RF_ChannelValue

Main:
       	jbclr  	       	TX_RX_Change_Flag
       	goto   	       	Main_RX
       	;=================================
Main_TX:
       	movai  	       	4
       	movra  	       	TX_RX_DataLength
       	
       	call   	       	ID1_Tab
       	movra  	       	TX_RX_DataLength+1
       	
       	call   	       	ID2_Tab
       	movra  	       	TX_RX_DataLength+2
       	
       	call   	       	ID3_Tab
       	movra  	       	TX_RX_DataLength+3

       	movai  	       	0x44
       	movra  	       	TX_RX_DataLength+4

        call   	       	RF_ResetWriteFIFO_Deal
        
        call   	       	RF_WriteFIFO_Deal
Main_TX_Loop:
        call   	       	RF_TX_Deal
        
        call   	       	RF_TX_PKT_Deal

       	bset   	       	TX_LED_P12

       	jbset  	       	TNms_Flag
       	goto   	       	Main_TX_Loop
       	bclr   	       	TNms_Flag

       	goto   	       	Main_1S_Deal
       	;====================================
Main_RX:
       	movai  	       	97
       	movra  	       	RF_RegAddr
       	call   	       	SPI_ReadReg_Deal

       	movai  	       	0x40
       	andar  	       	RF_RegData
       	jbclr  	       	Z
       	goto           	Main_RX_TimerBase

       	call   	       	RF_ReadFIFO_Deal

       	call   	       	RF_ResetReadFIFO_Deal
       	call   	       	RF_RX_Deal

       	jbclr  	       	RF_ReadFIFOError_Flag
       	goto   	       	Main_RX_TimerBase

       	movai  	       	4
        rsubar 	       	TX_RX_DataLength
        jbset  	       	Z
        goto   	       	Main_RX_TimerBase

       	call   	       	ID1_Tab
        rsubar 	       	TX_RX_DataLength+1
        jbset  	       	Z
        goto   	       	Main_RX_TimerBase

       	call   	       	ID2_Tab
        rsubar 	       	TX_RX_DataLength+2
        jbset  	       	Z
        goto   	       	Main_RX_TimerBase

       	call   	       	ID3_Tab
        rsubar 	       	TX_RX_DataLength+3
        jbset  	       	Z
        goto   	       	Main_RX_TimerBase

       	movai  	       	0x44
        rsubar 	       	TX_RX_DataLength+4
        jbset  	       	Z
        goto   	       	Main_RX_TimerBase

       	bset   	       	RX_LED_P11

Main_RX_TimerBase:
       	jbset  	       	TNms_Flag
       	goto   	       	Main_RX
       	bclr   	       	TNms_Flag
       	;==================================
Main_1S_Deal:
       	incr   	       	T1S_Num
       	movai  	       	125
       	rsubar 	       	T1S_Num
       	jbset  	       	C
       	goto   	       	Main
       	clrr   	       	T1S_Num

       	jbclr  	       	TX_RX_Change_Flag
       	goto   	       	Main_TX_RX_Change_Deal
       	bset   	       	TX_RX_Change_Flag
       	bclr   	       	TX_LED_P12

       	call   	       	RF_ResetReadFIFO_Deal
       	call   	       	RF_RX_Deal

       	goto   	       	Main
       	;---------------
Main_TX_RX_Change_Deal:
       	bclr   	       	TX_RX_Change_Flag
       	bclr   	       	RX_LED_P11   

       	call   	       	RF_Idle_Deal

       	goto   	       	Main


       	end    	
       	
       	

