#include <mc30p6080.inc>

;**************************************
; Fcpu=1/2M: 13
; Fcpu=1M: 30
; Fcpu=2M: 63
; Fcpu=4M: 130
; Fcpu=8M: 55
#define	Delay_100us_Num_Temp   	63
;**************************************
#define	RX_DataLengthMax_Value 	4
;**************************************
#define	SyncWord_Addr1 	       	72
#define	SyncWord_Data1 	       	0xAA

#define	SyncWord_Addr2 	       	73
#define	SyncWord_Data2 	       	0xBB

#define	SyncWord_Addr3 	       	78             	       	
#define	SyncWord_Data3 	       	0xCC

#define	SyncWord_Addr4 	       	79             	
#define	SyncWord_Data4 	       	0xDD
;**************************************
#define	RF_CLK         	       	P0,2
#define	RF_CSn         	       	P0,0
#define	RF_MOSI_MISO   	       	P0,1

#define	RF_MOSI_MISO_DDR       	DDR0,1

#define	TX_LED_P10     	       	P1,0
#define	RX_LED_P11     	       	P1,1
;**************************************
#define	RF_MOSI_Input  	       	1
#define	RF_MOSI_Output 	       	0
;**************************************
;ʱ˺ͽնӦĶֿ
;һʱΪ4msΪ500ms;һʱΪ8msΪ1000ms
#define	TNms_Value     	       	131;(256-131)*32us=4ms

;#define       	TNms_Value     	       	6;(256-6)*32us=8ms
;**************************************

cblock 	       	10h
acctemp
statustemp
Flag

TX_RX_DataLength
TX_RX_Data1
TX_RX_Data2
TX_RX_Data3
TX_RX_Data4

RF_InitIndex
RF_ChannelValue
RF_RegAddr
RF_RegData
RF_RegData_Temp
SPI_BUF
SPI_Cyc_Cnt

TX_RX_DataLength_Temp

Delay_100us_Num1
Delay_100us_Num2

T1S_Num
endc

#define	RF_ReadFIFOError_Flag  	Flag,0
#define	SPI_CKPHA_Flag 	       	Flag,1
#define	TNms_Flag      	       	Flag,2
#define	TX_RX_Change_Flag      	Flag,3

       	org    	       	0x3ff
       	goto   	       	Start
       	org    	       	0x00
       	goto   	       	Start

ID1_Tab:
       	retai  	       	0xFF
ID2_Tab:
       	retai  	       	0xFF
ID3_Tab:
       	retai  	       	0xFF

       	org    	       	08h
       	goto   	       	All_Int

#include "MC3090_3SPI_Demo.asm"

All_Int:
       	movra  	       	acctemp
       	swapar 	       	STATUS
       	movra  	       	statustemp

       	jbset  	       	T0IF
       	goto   	       	All_Int_Over
       	bclr   	       	T0IF

       	movai  	       	TNms_Value
       	movra  	       	T0CNT

       	bset   	       	TNms_Flag

All_Int_Over:
       	swapar 	       	statustemp
       	movra  	       	STATUS
       	swapr  	       	acctemp
       	swapar 	       	acctemp
       	retie 


Start:  
;=========  IO  ==================
;SPI_CSn=1
Start_Init_IO:
        movai  	       	0x01
        movra  	       	P0  
       	movai  	       	0x00
        movra  	       	DDR0
        movai  	       	0x01
        movra  	       	P0    

       	movai  	       	0x00
       	movra  	       	P1             	
        movai  	       	0x00
       	movra  	       	DDR1
       	movai  	       	0x00
       	movra  	       	P1
;========= CLR  RAM ==============
       	movai  	       	0x40
       	movra  	       	FSR
       	movai  	       	48
       	movra  	       	0x07
       	decr   	       	FSR
       	clrr   	       	INDF
       	djzr   	       	0x07
       	goto   	       	$-3
       	clrr   	       	INDF
       	clrr   	       	0x07
;=========  RF  ==================
       	call   	       	RF_Init_Deal
;=========  Timer  ===============
Start_Init_Timer:
       	movai  	       	0x05;0000 0101
       	movra  	       	T0CR
       	
       	movai  	       	TNms_Value
       	movra  	       	T0CNT

       	bclr   	       	T0IF
       	bset   	       	T0IE
       	bset   	       	GIE

Main:
       	movai  	       	1
       	movra  	       	RF_RegAddr
       	movai  	       	0xF9
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal
       
       	movai  	       	65
       	movra  	       	RF_RegAddr
       	movai  	       	0x01
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	movai  	       	68
       	movra  	       	RF_RegAddr
       	movai  	       	0xB0
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal
       
       	movai  	       	22
       	movra  	       	RF_RegAddr
       	movai  	       	0x83
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	movai  	       	14
       	movra  	       	RF_RegAddr
       	movai  	       	0x05
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal
       
       	movai  	       	15
       	movra  	       	RF_RegAddr
       	movai  	       	0x4B
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	goto   	       	$

       	end    	
       	
       	

